<!-- 计量文件公共模板 -->
<script lang="ts" setup>
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import addDialog from './addDialog.vue'
import type { fileListType, fileResType, fileSearchType } from '@/views/measure/file/file-interface'
import { deleteApi, exportFileApi, listPageApi, updateApi } from '@/api/measure/file'
import { getDictByCode } from '@/api/system/dict'
// import { exportExcel } from '@/utils/exportXlsx'
import { uploadApi } from '@/api/system/notice'
import { exportFile } from '@/utils/exportUtils'
const props = defineProps({
  name: {
    type: String,
    default: '',
  },
  authority: {
    type: String,
    required: true,
  },
})
const { proxy } = getCurrentInstance() as any
const searchQuery = reactive<fileSearchType>({
  fileNo: '', // 编号
  fileName: '', // 名称
  publishTime: '', // 发布时间
  fileCode: '', // 文件号
  effectiveTime: '', // 实施时间
  effectiveStatus: '', // 实施状态
  limit: 10,
  offset: 1,
  fileType: '', // 类型
}) // 查询参数
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref([
  { text: '名称', value: 'fileName', align: 'center', width: '130' },
  { text: '编号', value: 'fileNo', align: 'center' },
  { text: '文件号', value: 'fileCode', align: 'center' },
  { text: '发布时间', value: 'publishTime', align: 'center', width: '180' },
  { text: '实施时间', value: 'effectiveTime', align: 'center', width: '180' },
  { text: '实施状态', value: 'effectiveStatusName', align: 'center', width: '100' },
]) // 表格
const printObj = ref({
  id: 'print', // 需要打印元素的id
  popTitle: props.name, // 打印配置页上方的标题
  extraHead: '', // 最上方的头部文字，附加在head标签上的额外标签，使用逗号分割
  preview: false, // 是否启动预览模式，默认是false
  previewBeforeOpenCallback() { console.log('正在加载预览窗口！') }, // 预览窗口打开之前的callback
  previewOpenCallback() { console.log('已经加载完预览窗口，预览打开了！') }, // 预览窗口打开时的callback
  beforeOpenCallback() { console.log('开始打印之前！') }, // 开始打印之前的callback
  openCallback() { console.log('执行打印了！') }, // 调用打印时的callback
  closeCallback() { console.log('关闭了打印工具！') }, // 关闭打印的callback(无法区分确认or取消)
  clickMounted() { console.log('点击v-print绑定的按钮了！') },
  // url: 'http://localhost:8080/', // 打印指定的URL，确保同源策略相同
  // asyncUrl (reslove) {
  //   setTimeout(() => {
  //     reslove('http://localhost:8080/')
  //   }, 2000)
  // },
  standard: '',
  extarCss: '',
})
const list = ref([]) // 表格数据
const addRef = ref() // 添加/编辑/详情/组件
const dialogVisible = ref<boolean>(false) // 添加组件的显示与隐藏
// 获取类型
const fileTypeList = ref<fileResType[]>([])
const getType = async () => {
  const res = await getDictByCode('fileType')
  fileTypeList.value = res.data
  searchQuery.fileType = res.data.filter((item: fileResType) => item.name === props.name)[0].value
}
const effectiveStatusSelect = ref<fileResType[]>([])
// 获取实施状态
const getStatus = () => {
  getDictByCode('effectiveStatus').then((res) => {
    if (res.code === 200) {
      effectiveStatusSelect.value = res.data
    }
  })
}
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  listPageApi(searchQuery).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 详情
const detail = (row: fileListType) => {
  dialogVisible.value = true
  addRef.value.initDialog({
    ...row,
    fileType: searchQuery.fileType,
    title: '详情',
    fileTypeName: props.name,
  })
}
// 下载(单个)
const exportSelf = (row: fileListType) => {

}
// 废止
const abolish = (row: fileListType) => {
  ElMessageBox.confirm(
    `确认废止${row.fileName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      updateApi({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '操作成功',
          })
          getList()
        }
      })
    })
}
// 删除
const remove = (row: fileListType) => {
  ElMessageBox.confirm(
    `确认删除${row.fileName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteApi({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          getList()
        }
      })
    })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  searchQuery.fileNo = ''
  searchQuery.fileName = ''
  searchQuery.fileCode = ''
  searchQuery.publishTime = ''
  searchQuery.effectiveTime = ''
  searchQuery.effectiveStatus = ''
  getList()
}
// 模板下载
const templateDownload = () => {

}
// 新增
const add = () => {
  dialogVisible.value = true
  addRef.value.initDialog({
    fileType: searchQuery.fileType,
    title: '新增',
    fileTypeName: props.name,
  })
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })

  exportFileApi({ ...searchQuery, limit: undefined, offset: undefined }).then((res) => {
    exportFile(res.data, props.name)
    loading.close()
  }).catch((_) => {
    loading.close()
  })
}
// 打印
const print = () => {

}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传图片
  // console.log(event.target.files)
  // if (event.target.files[0].type === 'application/pdf') {
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    uploadApi(fd).then((res) => {
      if (res.code === 200) {
        ElMessage.success('上传成功')
      }
      else {
        ElMessage.error(res.message)
      }
    })
  }
//   }
//   else {
//     ElMessage.error('请上传pdf格式')
//   }
}
// 批量导入
const batchImport = () => {
  fileRef.value.click()
}
// 传给子组件的刷新事件
const refreshDta = () => {
  getList()
  dialogVisible.value = false
}
onMounted(() => {
  getStatus()
  getType().then((_) => {
    getList()
  })
})
</script>

<template>
  <div>
    <add-dialog v-show="dialogVisible" ref="addRef" @reset-data="refreshDta" />
    <!-- 布局 -->
    <app-container v-show="!dialogVisible">
      <!-- 筛选条件 -->
      <search-area :need-clear="true" @search="search" @clear="reset">
        <search-item>
          <el-input v-model="searchQuery.fileNo" placeholder="编号" clearable class="w-50 m-2 normal-input" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.fileName" placeholder="名称" clearable class="w-50 m-2 normal-input" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.fileCode" placeholder="文件号" clearable class="w-50 m-2 normal-input" />
        </search-item>
        <search-item>
          <el-select v-model="searchQuery.fileType" class="m-2 normal-select" placeholder="类别" clearable>
            <el-option
              v-for="item in fileTypeList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
        <search-item>
          <el-date-picker
            v-model="searchQuery.publishTime" type="datetime" format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
            placeholder="发布时间"
            class="normal-date"
            style="width: 155px;"
          />
        </search-item>
        <search-item>
          <el-date-picker
            v-model="searchQuery.effectiveTime" type="datetime" format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
            placeholder="实施时间"
            class="normal-date"
            style="width: 155px;"
          />
        </search-item>
        <search-item>
          <!-- <el-select v-model="searchQuery.effectiveStatus" class="m-2 normal-select" placeholder="实施状态">
            <el-option
              v-for="item in effectiveStatusSelect"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select> -->
          <el-input v-model.trim="searchQuery.effectiveStatus" class="m-2 normal-select" placeholder="实施状态" />
        </search-item>
      </search-area>
      <table-container>
        <!-- 表头区域 -->
        <template #btns-right>
          <input v-show="(searchQuery.limit === 0)" ref="fileRef" type="file" multiple @change="onFileChange">
          <icon-button v-if="proxy.hasPerm(`/file/${authority}/add`)" icon="icon-add" title="新建" @click="add" />
          <icon-button v-if="proxy.hasPerm(`/file/${authority}/import`)" icon="icon-import" title="批量导入" @click="batchImport" />
          <icon-button v-if="proxy.hasPerm(`/file/${authority}/mould`)" icon="icon-template" title="模板下载" @click="templateDownload" />
          <icon-button v-if="proxy.hasPerm(`/file/${authority}/export`)" icon="icon-export" title="导出" @click="exportExcelBtn" />
          <icon-button v-if="proxy.hasPerm(`/file/${authority}/print`)" v-print="printObj" icon="icon-print" title="打印" @click="print" />
        </template>
        <!-- 表格区域 -->
        <normal-table
          id="print"
          :data="list" :total="total" :columns="columns as any"
          :is-showmulti-select="true"
          :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
          :list-loading="loadingTable"
          @change="changePage"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column label="操作" align="center" width="200">
              <template #default="{ row }">
                <el-button v-if="proxy.hasPerm(`/file/${authority}/detail`)" size="small" type="primary" link @click="detail(row)">
                  查看
                </el-button>
                <el-button v-if="proxy.hasPerm(`/file/${authority}/download`)" size="small" type="primary" link @click="exportSelf(row)">
                  下载
                </el-button>
                <el-button v-if="proxy.hasPerm(`/file/${authority}/abolish`)" size="small" :type="row.effectiveStatus === '3' ? 'info' : 'primary'" link :disabled=" row.effectiveStatus === '3'" @click="abolish(row)">
                  废止
                </el-button>
                <el-button v-if="proxy.hasPerm(`/file/${authority}/delete`)" size="small" type="danger" link @click="remove(row)">
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 154px !important;
}

.normal-date {
  width: 154px !important;
}

.normal-select {
  width: 154px !important;
}

:deep(.el-table__header) {
  background-color: #bbb;
}
</style>
